/*
 * 날짜포맷에 맞는지 검사
 */
function isDateFormat(d) {
    var df = /[0-9]{4}-[0-9]{2}-[0-9]{2}/;
    return d.match(df);
}

/*
 * 윤년여부 검사
 */
function isLeaf(year) {
    var leaf = false;

    if(year % 4 == 0) {
        leaf = true;

        if(year % 100 == 0) {
            leaf = false;
        }

        if(year % 400 == 0) {
            leaf = true;
        }
    }

    return leaf;
}

/*
 * 날짜가 유효한지 검사
 * 예) '2009-02-10'
 */
function isValidDate(d) {
    // 포맷에 안맞으면 false리턴
    if(!isDateFormat(d)) {
        return false;
    }

    var month_day = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

    var dateToken = d.split('-');
    var year = Number(dateToken[0]);
    var month = Number(dateToken[1]);
    var day = Number(dateToken[2]);
    
    // 날짜가 0이면 false
    if(day == 0) {
        return false;
    }

    var isValid = false;

    // 윤년일때
    if(isLeaf(year)) {
        if(month == 2) {
            if(day <= month_day[month-1] + 1) {
                isValid = true;
            }
        } else {
            if(day <= month_day[month-1]) {
                isValid = true;
            }
        }
    } else {
        if(day <= month_day[month-1]) {
            isValid = true;
        }
    }

    return isValid;
}


 //DateCmp(date1, date2)
 //date_Format(ymd, formatmask)
 //date_FormatYM(ym, formatmask)
 //format_YYYYMM(object)
 // format_YYYYMMDD(object)
 // getCurrentTime()
 // getDay()
 // getDayInterval(time1,time2)
 // getHour()
 // getHourInterval(time1,time2)
 // getMMDD( separator)
 // getMonth()
 // getMonthInterval(time1,time2)
 // getRelativeTime(y,m,d,h)
 // getYear()
 // getYYYYMM( separator)
 // getYYYYMMDD( separator)
 // isDate(y,m,d)
 // isDateYM(ym)
 // isDateYMD(ymd)
 // isDateYYYY(yyyy)
 // isDateYYYYMM( yyyymm )
 // isFormatDate(ymd, formatmask)
 // isFormatDateYM(ym, formatmask)
 // isFutureTime(time)
 // isPastTime(time)
 // isValidDay(yyyy, mm, dd)
 // isValidHour(hh)
 // isValidMin(mi)
 // isValidMonth(mm)
 // isValidTime(time)
 // isValidTimeFormat(time)
 // isYM(y,m)
 // isYunNyun(y)
 // shiftTime(time,y,m,d,h)
 // toTimeObject(time)
 // toTimeString(date)
 // offMoneyFormat( obj ) 
 // onMoneyFormat( obj )
 // cala_day(year, month, day)
 // cala_weekday( x_nMonth, x_nDay, x_nYear)
 // day_display(x_nDayOfWeek)



/*
 * 유효한(존재하는) 월(月)인지 체크
 * 예) '1'에서 12까지의 월을 입력
 * 결과 : Boolean 
 */
 
function isValidMonthChk(num) {
/////////////////////////////////////////////////////
//유효한(존재하는) 월(月)인지 체크
 	if(num == "") return false;
 	try{
 		if(isNaN(num)) 
			throw new Error(100);
 		var m = parseInt(num,10);
 		if(! (m >= 1 && m <= 12)){
 			throw new Error(100);
 		}
 		if(num.length == 1){
 			num = "0"+num;
 		}
 	}catch(e){
		return false;
    }
    return true;
 }
 
