﻿///////////////////////////////////////////////////////////////////////
// Variables
///////////////////////////////////////////////////////////////////////
// 외부에서 세팅을 해야하는 값들
var lib_strDivPosition;			// 하단 Tabpage 영역
var lib_strTabButtonArea;		// TabButton들 영역
var lib_strTabButtonPadding;	// TabButton의 Padding

// 해도 좋고 안해도 별 상관없는 값들
var lib_nCloseButtonSize = -1;
var lib_nTabButtonMargin = 2;
var lib_objForm = this;
var lib_nButtonBorderSize = 1;
var lib_strInitialTabList = null;

var lib_strTabButtonDivStyle = "";			// TabButton Div 영역의 Style
var lib_strTabButtonStaticStyle = "";		// TabButton Static 영역의 Style
var lib_strTabButtonCloseButtonStyle = "";	// TabButton Close Button 영역의 Style

var lib_strTabDivStyle = "";				// Tabpage Div 영역의 Style

// User Event
var lib_eventTabOnChange = null;			// onchange Event;		onchange(obj:Form,e:TabIndexChangeEventInfo);
var lib_eventTabOnRClick = null;			// onrclick Event; 		onrclick((obj:Div,e:MouseEventInfo,strTabId);
var lib_eventTabButtonOnCreate = null;
var lib_eventTabButtonOnCreated = null;

// 잘 아는게 아니면 손 안대는게 좋은값들
var lib_rectDiv = null;					// Div 영역
var lib_rectTabButton = null;			// Button 영역
var lib_rectTabPadding = null;			// Text Padding
var lib_arrTabpage = null;				// TabId List
var lib_nTabIndex = -1;					// Tab Index
var lib_strButtonAdding = "_tabbutton";
var lib_arrDeleted = null;

///////////////////////////////////////////////////////////////////////
// Init Functions
// Form에서 반드시 호출해야 하는 Funtions
///////////////////////////////////////////////////////////////////////
function lib_funcOnload()		// Form의 onload에서 호출한다.
{
	if(lib_arrDeleted == null)
		lib_arrDeleted = new Array;
	
	// Tabpage Id List 관리
	if(lib_arrTabpage == null)
		lib_arrTabpage = new Array;
	if(lib_strInitialTabList != null)
	{
		var arrDivList = liv_strInitialTabList.split(" ");
		var i;
		for(i=0;i<arrDivList.length;i++)
			lib_arrTabpage[i] = arrDivList[i];
	}
	
	// Tab Div 영역
	if(lib_rectDiv == null)
		lib_rectDiv = new Rect;

	var arrRectDiv = lib_strDivPosition.split(" ");
	if(arrRectDiv.length >= 4)
	{
		lib_rectDiv.left = arrRectDiv[0];
		lib_rectDiv.top = arrRectDiv[1];
		lib_rectDiv.right = arrRectDiv[2];
		lib_rectDiv.bottom = arrRectDiv[3];
	}
	
	// Tab Button 영역
	if(lib_rectTabButton == null)
		lib_rectTabButton = new Rect;
	var arrRectButton = lib_strTabButtonArea.split(" ");
	if(arrRectButton.length >= 4)
	{
		lib_rectTabButton.left = arrRectButton[0];
		lib_rectTabButton.top = arrRectButton[1];
		lib_rectTabButton.right = arrRectButton[2];
		lib_rectTabButton.bottom = arrRectButton[3];
	}
	
	// Tab Button Padding
	if(lib_rectTabPadding == null)
		lib_rectTabPadding = new Rect;
	var arrRectPadding = lib_strTabButtonPadding.split(" ");
	if(arrRectButton.length >= 4)
	{
		lib_rectTabPadding.left = arrRectPadding[0];
		lib_rectTabPadding.top = arrRectPadding[1];
		lib_rectTabPadding.right = arrRectPadding[2];
		lib_rectTabPadding.bottom = arrRectPadding[3];
	}
}

///////////////////////////////////////////////////////////////////////
// Method Functions
// Tab을 다루기 위해 사용하는 Function
///////////////////////////////////////////////////////////////////////
// Util Functions
//---------------------------------------------------------
// lib_funcAddTab(strId,strTitle,nWidth,strUrl)
// Tab을 추가한다.
// strId 	: 추가된 Tabpage의 Id
// strTitle	: Tab Button에 보일 Text
// nWidth : Tab Button의 Width
// strUrl : 추가된 Tabpage에 열 Url :없으면 null
//---------------------------------------------------------
function lib_funcAddTab(strId,strTitle,nWidth,strUrl)
{
	if(lib_funcCreateTab(strId,strTitle,nWidth,strUrl) == true)
	{
		var newIndex = lib_funcGetTabpageCount();
		lib_arrTabpage[newIndex] = strId;
	}
	lib_funcArrangeTab(true);
}

//---------------------------------------------------------
// lib_funcInsertTab(nIndex,strId,strTitle,nWidth,strUrl)
// Tab을 Insert 한다.
// nIndex 	: Tab을 추가할 Index (0~n)
// strId 	: 추가된 Tabpage의 Id
// strTitle	: Tab Button에 보일 Text
// nWidth : Tab Button의 Width
// strUrl : 추가된 Tabpage에 열 Url :없으면 null
//---------------------------------------------------------
function lib_funcInsertTab(nIndex,strId,strTitle,nWidth,strUrl)
{
	if(nIndex >= lib_funcGetTabpageCount())
	{
		trace("Insert 위치가 범위를 넘어갑니다.");
		return;
	}
	if(lib_funcCreateTab(strId,strTitle,nWidth,strUrl) == true)
	{
		var i;
		for(i=lib_funcGetTabpageCount();i>nIndex;i--)
			lib_arrTabpage[i] = lib_arrTabpage[i-1];
		lib_arrTabpage[nIndex] = strId;
	}
	lib_funcArrangeTab(true);
}

//---------------------------------------------------------
// lib_funcDeleteTabByIndex(nIndex)
// Tab을 삭제 한다.
// nIndex 	: 삭제할 Tab의 Index (0~n-1)
//---------------------------------------------------------
function lib_funcDeleteTabByIndex(nIndex)
{
	if(nIndex >= lib_funcGetTabpageCount() || nIndex < 0)
	{
		trace("Delete 위치가 범위를 넘어갑니다.");
		return;
	}
	
	var tabid = lib_arrTabpage[nIndex];
	
	if(nIndex == lib_nTabIndex)
	{
		if(nIndex == 0 && lib_funcGetTabpageCount() == 1)
		{
			lib_funcselectTabbyIndex(-1);
		}
		else if(nIndex < lib_funcGetTabpageCount()-1)
		{
			lib_funcselectTabbyIndex(nIndex+1);
			lib_nTabIndex = nIndex;
		}
		else
		{
			lib_funcselectTabbyIndex(nIndex-1);
		}
	}
	else if(nIndex < lib_nTabIndex)
		lib_nTabIndex --;
	
	lib_arrTabpage.splice(nIndex,1);
	
	var buttonDiv = lib_objForm.components[tabid+lib_strButtonAdding];
	if(buttonDiv != null)
	{
		lib_objForm.removeChild(buttonDiv);
		lib_arrDeleted[lib_arrDeleted.length] = buttonDiv;
		//buttonDiv.destroy();
		//buttonDiv = null;
	}

	var pageDiv = lib_objForm.components[tabid];
	if(pageDiv != null)
	{
		lib_objForm.removeChild(pageDiv);
		pageDiv.destroy();
		pageDiv = null;
	}

	lib_funcArrangeTab(false);
}

//---------------------------------------------------------
// lib_funcDeleteTabById(strTabId)
// Tab을 삭제 한다.
// strTabId 	: 삭제할 Tab의 Id
//---------------------------------------------------------
function lib_funcDeleteTabById(strTabId)
{
	var index = lib_funcFindTabById(strTabId);
	if(index < 0)
		trace("Delete 하려는 Id를 찾을 수 없습니다.");
	else
		lib_funcDeleteTabByIndex(index);
}

//---------------------------------------------------------
// lib_funcFindTabById(strTabId)
// TabId로 index를 찾는다.
// strTabId 	: Index를 찾을 Tab의 Id
//---------------------------------------------------------
function lib_funcFindTabById(strTabId)
{
	var i;
	for(i=0;i<lib_funcGetTabpageCount();i++)
	{
		if(lib_arrTabpage[i] == strTabId)
			return i;
	}
	return -1;
}

//---------------------------------------------------------
// lib_funcFindTabByIndex(nIndex)
// Index로 TabId를 찾는다.
// nIndex 	: TabId를 찾을 Index
//---------------------------------------------------------
function lib_funcFindTabByIndex(nIndex)
{
	if(nIndex >= lib_funcGetTabpageCount())
	{
		trace("찾는 위치가 범위를 넘어갑니다.");
		return;
	}
	return lib_arrTabpage[nIndex];
}

//---------------------------------------------------------
// lib_funcSelectTabByIndex(nIndex)
// Index로 Tabpage를 활성화 한다.
// nIndex 	: TabId를 찾을 Index
//---------------------------------------------------------
function lib_funcselectTabbyIndex(nIndex)
{
	if(nIndex >= lib_funcGetTabpageCount())
	{
		trace("찾는 위치가 범위를 넘어갑니다.");
		return;
	}
	if(nIndex != lib_nTabIndex)
	{
		if(lib_eventTabOnChange != null)
		{
			lib_eventTabOnChange(lib_objForm,lib_nTabIndex,nIndex);
		}
		lib_nTabIndex = nIndex;
	}
	lib_funcArrangeTab(true);
}

//---------------------------------------------------------
// lib_funcSelectTabById(strTabId)
// TabId로 Tabpage를 활성화 한다.
// strTabId 	: Index를 찾을 Tab의 Id
//---------------------------------------------------------
function lib_funcSelectTabById(strTabId)
{
	var index = lib_funcFindTabById(strTabId);
	lib_funcselectTabbyIndex(index);
}

function lib_funcGetTabpageCount()
{
	return lib_arrTabpage.length;
}

///////////////////////////////////////////////////////////////////////
// Private Functions
// 잘 아는게 아니라면 손대지 않는게 좋은 Function
///////////////////////////////////////////////////////////////////////
function lib_funcArrangeTab(bGarbage)
{
	var i;
	var tabbuttonpos = lib_rectTabButton.left;
	for(i=0;i<lib_funcGetTabpageCount();i++)
	{
		var tabid = lib_arrTabpage[i];
		var tabbuttondiv = lib_objForm.components[tabid+lib_strButtonAdding];
		if(tabbuttondiv != null)
		{
			tabbuttondiv.move(tabbuttonpos,tabbuttondiv.position.top,tabbuttonpos+tabbuttondiv.position.width,tabbuttondiv.position.bottom);
			tabbuttonpos = tabbuttondiv.position.right + lib_nTabButtonMargin;
		}
		
		var tabDiv = lib_objForm.components[tabid];
		if(tabDiv != null)
			tabDiv.visible = (i == lib_nTabIndex);
	}
	
	if(bGarbage)
	{
		for(i=0;i<lib_arrDeleted.length;i++)
		{
			var delObj = lib_arrDeleted[0];
			delObj.destroy();
			delObj = null;
			lib_arrDeleted.splice(0,1);
		}
	}
}

function lib_funcCreateTab(strId,strTitle,nWidth,url)
{
	var tabindex = lib_funcFindTabById(strId);
	if(tabindex > -1)
		return false;

	var tabDiv = lib_funcCreateDiv(strId,url);
	if(tabDiv != null)
	{
		tabDiv.title = strTitle;
		var tabbutton = lib_funcCreateButton(strId+lib_strButtonAdding,strTitle,nWidth);
		if(tabbutton != null)
			return true;
	}
	return false;
}

function lib_funcCreateButton(strButtonId,strTitle,nWidth)
{
	var tabButtonDiv = new Div;
	tabButtonDiv.init(strButtonId,lib_rectTabButton.left,lib_rectTabButton.top,lib_rectTabButton.left+nWidth,lib_rectTabButton.bottom);
	lib_objForm.addChild(tabButtonDiv);
	tabButtonDiv.onclick.setHandler(lib_eventTabSelect_onclick);
	tabButtonDiv.onrbuttonup.setHandler(lib_eventTab_onrbuttonup);
	tabButtonDiv.style=lib_strTabButtonDivStyle;
	tabButtonDiv.scrollbars = "none";
	tabButtonDiv.show();
	
	if(lib_eventTabButtonOnCreate != null)
		lib_eventTabButtonOnCreate(tabButtonDiv);

	var tabButtonStatic = new Static;
	tabButtonStatic.init("tabTitle",lib_rectTabPadding.left,lib_rectTabPadding.top,nWidth - lib_rectTabPadding.right,lib_rectTabButton.height() - lib_rectTabPadding.bottom);
	tabButtonDiv.addChild(tabButtonStatic);
	tabButtonStatic.text = strTitle;
	tabButtonStatic.onclick.setHandler(lib_eventTabSelect_onclick);
	tabButtonStatic.style=lib_strTabButtonStaticStyle;
	tabButtonStatic.show();

	var clientHeight = lib_rectTabButton.height() - lib_nButtonBorderSize*2;
	var clientWidth = nWidth - lib_nButtonBorderSize*2;
	var tabButtonClose = new Button;
	if(lib_nCloseButtonSize > 0)
	{
		var padding = (clientHeight - lib_nCloseButtonSize) / 2;
		tabButtonClose.init("tabClose",clientWidth-padding-lib_nCloseButtonSize,padding,clientWidth-padding,lib_nCloseButtonSize + padding);
	}
	else
	{
		var btnSize = clientHeight - lib_rectTabPadding.top - lib_rectTabPadding.bottom ;
		var padding = (clientHeight - btnSize) / 2;
		tabButtonClose.init("tabClose",clientWidth-padding-btnSize,padding,clientWidth-padding,btnSize + padding);
	}
	tabButtonDiv.addChild(tabButtonClose);
	tabButtonClose.onclick.setHandler(lib_eventTabClose_onclick);
	tabButtonClose.style=lib_strTabButtonCloseButtonStyle;
	tabButtonClose.show();
	
	if(lib_eventTabButtonOnCreated != null)
		lib_eventTabButtonOnCreated(tabButtonDiv);
	
	return tabButtonDiv;
}

function lib_funcCreateDiv(strTabId,url)
{
	var tabpageDiv = new Div;
	tabpageDiv.init(strTabId,lib_rectDiv.left,lib_rectDiv.top,lib_rectDiv.right,lib_rectDiv.bottom);
	lib_objForm.addChild(tabpageDiv);
	tabpageDiv.style=lib_strTabDivStyle;
	tabpageDiv.show();
	if(url != null)
		tabpageDiv.url = url;
	return tabpageDiv;
}

///////////////////////////////////////////////////////////////////////
// Event
// 잘 아는게 아니라면 손대지 않는게 좋은 Function
///////////////////////////////////////////////////////////////////////
function lib_eventTabClose_onclick(obj:Button,  e:ClickEventInfo)
{
	var tabid = obj.parent.id.substr(0,obj.parent.id.search(lib_strButtonAdding));
	lib_funcDeleteTabById(tabid);
}

function lib_eventTab_onrbuttonup(obj:Div,  e:MouseEventInfo)
{
	if(lib_eventTabOnRClick == null)
		return;
	if(obj instanceof Div)
	{
		var tabid = obj.id.substr(0,obj.id.search(lib_strButtonAdding));
		lib_eventTabOnRClick(obj,e,tabid);
	}
}

function lib_eventTabSelect_onclick(obj,  e:ClickEventInfo)
{
	if(obj instanceof Div)
	{
		var tabid = obj.id.substr(0,obj.id.search(lib_strButtonAdding));
		lib_funcSelectTabById(tabid);
	}
	else if(obj instanceof Static)
	{
		var tabid = obj.parent.id.substr(0,obj.parent.id.search(lib_strButtonAdding));
		lib_funcSelectTabById(tabid);
	}
}